#
# (c) 2004 Ivan 'Dark Dragon' Tivonenko
#
# Contents are licensed under the Nebula license.
#

import os, time
from cc_script_metainfo_scanner import CCScriptMetaInfoScanner
from xml_class_info_writer import XMLClassInfoWriter


xml_dir =  'interfacedefs'
if not os.path.exists(xml_dir): os.mkdir(xml_dir)

exclude_files = ['nebulajava.cc']
exclude_dirs = ['microtcl', 'lua']
dir_to_parse = '../code'
#dir_to_parse = '../../..'

found_classes = []

def dir_visitor(arg, dirname, names):
  for name in names:
    if name in exclude_files: continue
    fullfilename = os.path.join(dirname, name)
    if name in exclude_dirs:
      if os.path.isdir(fullfilename):
        del(names[names.index(name)])
        continue

    if not os.path.isfile(fullfilename): continue 
    pair = os.path.splitext(name)
    ext = pair[1]
    if ext == '.cc':
      print 'parsing file: ', name
      file = open( fullfilename, 'r' )
      scanner = CCScriptMetaInfoScanner( file, fullfilename )
      value, text = scanner.read()
      if scanner.scriptclass != '': 
        found_classes.append(scanner)




t1 = time.clock()
os.path.walk(dir_to_parse, dir_visitor, '')
t2 = time.clock()

xmlwriter = XMLClassInfoWriter()
for class_info in found_classes:
  #print class_info
  filename = os.path.join(xml_dir, class_info.scriptclass + '.xml')
  file = open(filename, 'w+')
  print "Writing %s" % class_info.scriptclass
  xmlwriter.WriteInfo(class_info, file)
  file.close()

t3 = time.clock()

time_taken = t3 - t1
print "Time taken: %s sec (%s min)" % (time_taken, time_taken / 60.0)
