#
# (c) 2004 Ivan 'Dark Dragon' Tivonenko
#
# Contents are licensed under the Nebula license.
#
from xml.dom import minidom


class XMLClassInfoWriter(object):
#  def __init__(self, class_info, file_obj):
#    self.__class_info = class_info
#    self.__file_obj = file_obj


  def __process_args(self, direction_name, cmd_elem, cmd, xd):
    inp_elem = xd.createElement(direction_name + "_args")
    cmd_elem.appendChild(inp_elem)
    for input_arg in cmd[direction_name]:
      #print input_arg
      arg_elem = xd.createElement("arg")
      inp_elem.appendChild(arg_elem)

      elem = xd.createElement("type")
      elem.appendChild(xd.createTextNode(input_arg['type']))
      arg_elem.appendChild(elem)

      elem = xd.createElement("name")
      elem.appendChild(xd.createTextNode(input_arg['name']))
      arg_elem.appendChild(elem)

      if 'enum' in input_arg:
        elem = xd.createElement("enum")
        arg_elem.appendChild(elem)
        for enum_item in input_arg['enum']:
          elem1 = xd.createElement("enum_item")
          elem1.appendChild(xd.createTextNode(enum_item))
          elem.appendChild(elem1)
    

  def WriteInfo(self, class_info, file_obj):
    """
      Writes class info into xml file.
    """
    xd = minidom.Document()
    class_elem = xd.createElement("class")
    xd.appendChild(class_elem)

    elem = xd.createElement("name")
    elem.appendChild(xd.createTextNode(class_info.cppclass))
    class_elem.appendChild(elem)
    elem = xd.createElement("scriptname")
    elem.appendChild(xd.createTextNode(class_info.scriptclass))
    class_elem.appendChild(elem)
    elem = xd.createElement("superclass")
    elem.appendChild(xd.createTextNode(class_info.superclass))
    class_elem.appendChild(elem)
    elem = xd.createElement("classinfo")
    elem.appendChild(xd.createCDATASection(class_info.classinfo.strip()))
    class_elem.appendChild(elem)


    cmds_elem = xd.createElement("cmds")
    class_elem.appendChild(cmds_elem)
    for cmd_name in class_info.cmds:
      cmd = class_info.cmds[cmd_name]
      cmd_elem = xd.createElement("cmd")
      cmds_elem.appendChild(cmd_elem)

      elem = xd.createElement("name")
      elem.appendChild(xd.createTextNode(cmd_name))
      cmd_elem.appendChild(elem)
      elem = xd.createElement("info")
      elem.appendChild(xd.createCDATASection(cmd['info'].strip()))
      cmd_elem.appendChild(elem)


      self.__process_args('input', cmd_elem, cmd, xd)
      self.__process_args('output', cmd_elem, cmd, xd)

    xd.writexml(file_obj, addindent="  ", newl="\n")
